unit UnidadMenuPrincipal;

{$R WinXP.res}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DateUtils, Buttons, StdCtrls, ComCtrls, ExtCtrls, shellapi, ThemeMgr;

type
  TformMenuPrincipal = class(TForm)
    opTipoFecha: TRadioGroup;
    GroupBox1: TGroupBox;
    txtFecha: TDateTimePicker;
    txtHora: TDateTimePicker;
    GroupBox2: TGroupBox;
    dlAbrir: TOpenDialog;
    bModificarFecha: TBitBtn;
    bSeleccionarFichero: TBitBtn;
    txtFichero: TEdit;
    lfCreacion: TLabel;
    lfModificacion: TLabel;
    lfUltimoAcceso: TLabel;
    LWEB: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Shape1: TShape;
    Shape2: TShape;
    Shape3: TShape;
    Shape4: TShape;
    Shape5: TShape;
    Shape6: TShape;
    StatusBar1: TStatusBar;
    ThemeManager1: TThemeManager;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Shape7: TShape;
    procedure bModificarFechaClick(Sender: TObject);
    procedure bSeleccionarFicheroClick(Sender: TObject);
    procedure obtenerDatosFichero;
    procedure LWEBClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);

    //para arrastrar y soltar
    procedure SoltarFichero  (var Msg: TWMDropFiles); message WM_DROPFILES;

  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  formMenuPrincipal: TformMenuPrincipal;

implementation

uses UnidadUtilidadFechas;

{$R *.dfm}

procedure TformMenuPrincipal.SoltarFichero (var Msg : TWMDropFiles);
var
  CFileName: array[0..MAX_PATH] of Char;
begin
  try
    if DragQueryFile(Msg.Drop, 0, CFileName, MAX_PATH) > 0 then
    begin
      txtFichero.Text := CFileName;
      obtenerDatosFichero;
      Msg.Result := 0;
    end;
  finally
    DragFinish(Msg.Drop); //finaliza arrastrar y soltar
  end;
end;

procedure TformMenuPrincipal.bSeleccionarFicheroClick(Sender: TObject);
begin
  if dlAbrir.Execute then
  begin
    bModificarFecha.Enabled := true;
    txtFichero.Text := dlAbrir.FileName;
    obtenerDatosFichero;
  end;
end;

procedure TformMenuPrincipal.obtenerDatosFichero;
var
  CreationDate,LastModifiedDate,LastAccessedDate : TDateTime;
begin

  obtenerFechaFichero (txtFichero.Text, CreationDate, fdkCreated);
  obtenerFechaFichero (txtFichero.Text, LastModifiedDate, fdkLastModified);
  obtenerFechaFichero (txtFichero.Text, LastAccessedDate, fdkLastAccessed);

  lfCreacion.Caption := FormatDateTime('dd/mm/yyyy hh:mm:ss', CreationDate);
  lfModificacion.Caption := FormatDateTime('dd/mm/yyyy hh:mm:ss', LastModifiedDate);
  lfUltimoAcceso.Caption := FormatDateTime('dd/mm/yyyy hh:mm:ss', LastAccessedDate);
end;

procedure TformMenuPrincipal.bModificarFechaClick(Sender: TObject);
begin
  txtFecha.Time := txtHora.Time;
  case opTipoFecha.ItemIndex of
    0 : cambiarFechaFichero (txtFichero.Text, txtFecha.DateTime, fdkCreated);
    1 : cambiarFechaFichero (txtFichero.Text, txtFecha.DateTime, fdkLastModified);
    2 : cambiarFechaFichero (txtFichero.Text, txtFecha.DateTime, fdkLastAccessed);
  end;
  obtenerDatosFichero;
end;

procedure TformMenuPrincipal.LWEBClick(Sender: TObject);
begin
  ShellExecute(Handle, Nil, PChar('http://www.ajpdsoft.com'),
      Nil, Nil, SW_SHOWNORMAL);
end;

procedure TformMenuPrincipal.FormCreate(Sender: TObject);
begin
  //permitimos arrastrar y soltar
  DragAcceptFiles(Handle, True);

  txtFecha.DateTime := Now;
  txtHora.DateTime := Now;
end;

end.
